/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (I)         *
 *            - vO~O̊bE\[XECxg -             *
 *                                                                     *
 *      Copyright 1994,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>
#include <signal.h>

static XtSignalId signal_id;
static int sig_count;  /* 󂯎VOǐ */

/* (3) VOiEnh */
static void sig_handler(sig)
    int sig;
{
    printf("A signal is received.\n");
    /* VOi̎ML^AɌĂяoVOiER[obNw */
    XtNoticeSignal(signal_id);
    sig_count++;  /* 󂯎VOǐ𐔂 */
}

/* (1) VOiER[obN */
static void SignalCB(client_data, id)
    XtPointer   client_data;  /* o^ɓnĂNCAgEf[^ */
    XtSignalId *id;           /* VOiER[obN ID */
{
    /* VOi̓VOiubNĂ */
    sigset_t sig_mask, save_mask;
    sigemptyset(&sig_mask);
    sigaddset(&sig_mask, SIGUSR1);
    sigprocmask(SIG_BLOCK, &sig_mask, &save_mask);

    /* ŃVOiɑ΂ۂ̏{ */
    printf("Signal Callback:  %d signals were sent.\n", sig_count);

    sigprocmask(SIG_SETMASK, &save_mask, NULL); /* ubNԂɖ߂ */
    sig_count = 0;  /* VOǐZbg */
}

/* ʂ̃R[obN֐ */
static void ButtonCB(w, client_data, call_data)
    Widget     w;
    XtPointer  client_data;
    XtPointer  call_data;
{
    int i;

    printf("Button Callback starts.\n");
    for (i = 0; i < 10; i++) {
        printf("Button Callback is processed.\n");
        sleep(1);  /* ł̓{^ꂽƂ̍Ƃ{ */
    }
    printf("Button Callback ends.\n");
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, button;
    Arg    al[20];
    int    ac;
    struct sigaction sigact;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;  /* X11R6 ł̏̊֐ */
    toplevel = XtOpenApplication(&app_context, "Signalcb", NULL, 0,
                        &argc, argv, NULL, sessionShellWidgetClass, al, ac);

    /* (4) VOiEnho^ */
    sigact.sa_handler = sig_handler;
    sigemptyset(&sigact.sa_mask);
    sigaddset(&sigact.sa_mask, SIGUSR2);
    sigact.sa_flags = NULL;
    sigaction(SIGUSR1, &sigact, NULL);
    sig_count = 0;

    /* (2) VOiER[obNo^ */
    signal_id = XtAppAddSignal(app_context, SignalCB, NULL);

    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    ac = 0;
    button = XmCreatePushButton(panel, "button", al, ac);
    XtManageChild(button);
    XtAddCallback(button, XmNactivateCallback, ButtonCB, NULL);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
